# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from lighting_msgs/DmxCommand.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import lighting_msgs.msg

class DmxCommand(genpy.Message):
  _md5sum = "7a8beef39da2352041dd0af2417e2173"
  _type = "lighting_msgs/DmxCommand"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """int8 DISPLAY=0     # Immediatly display frames, ignores name
int8 PLAY=1        # Start playback of named command
int8 STOP=2        # Stop playback of named command if supplied, stops all running commands if name is empty
int8 REMOVE=3      # Remove stored frame with supplied name. Empty name removes all stored frames
int8 STORE=4       # Store the supplied frames, non-empty name is required
int8 LOAD=5        # Load stored command from disk

int8 action
string name
DmxFrame[] layers
bool loop
string next

================================================================================
MSG: lighting_msgs/DmxFrame
DmxValue[] values
DmxEasing[] easings
uint32 delayMs
uint32 durationMs

================================================================================
MSG: lighting_msgs/DmxValue
uint32 universe
uint32 offset
uint8[] data

================================================================================
MSG: lighting_msgs/DmxEasing
DmxValue[] start
DmxValue[] end
uint32 delayMs
uint32 durationMs
uint8 curve

#Easing curve types
uint8 Linear = 0
uint8 InQuad = 1
uint8 OutQuad = 2
uint8 InOutQuad = 3
uint8 OutInQuad = 4
uint8 InCubic = 5
uint8 OutCubic = 6
uint8 InOutCubic = 7
uint8 OutInCubic = 8
uint8 InQuart = 9
uint8 OutQuart = 10
uint8 InOutQuart = 11
uint8 OutInQuart = 12
uint8 InQuint = 13
uint8 OutQuint = 14
uint8 InOutQuint = 15
uint8 OutInQuint = 16
uint8 InSine = 17
uint8 OutSine = 18
uint8 InOutSine = 19
uint8 OutInSine = 20
uint8 InExpo = 21
uint8 OutExpo = 22
uint8 InOutExpo = 23
uint8 OutInExpo = 24
uint8 InCirc = 25
uint8 OutCirc = 26
uint8 InOutCirc = 27
uint8 OutInCirc = 28
uint8 InElastic = 29
uint8 OutElastic = 30
uint8 InOutElastic = 31
uint8 OutInElastic = 32
uint8 InBack = 33
uint8 OutBack = 34
uint8 InOutBack = 35
uint8 OutInBack = 36
uint8 InBounce = 37
uint8 OutBounce = 38
uint8 InOutBounce = 39
uint8 OutInBounce = 40
uint8 Custom = 45

"""
  # Pseudo-constants
  DISPLAY = 0
  PLAY = 1
  STOP = 2
  REMOVE = 3
  STORE = 4
  LOAD = 5

  __slots__ = ['action','name','layers','loop','next']
  _slot_types = ['int8','string','lighting_msgs/DmxFrame[]','bool','string']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       action,name,layers,loop,next

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(DmxCommand, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.action is None:
        self.action = 0
      if self.name is None:
        self.name = ''
      if self.layers is None:
        self.layers = []
      if self.loop is None:
        self.loop = False
      if self.next is None:
        self.next = ''
    else:
      self.action = 0
      self.name = ''
      self.layers = []
      self.loop = False
      self.next = ''

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      buff.write(_struct_b.pack(self.action))
      _x = self.name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.layers)
      buff.write(_struct_I.pack(length))
      for val1 in self.layers:
        length = len(val1.values)
        buff.write(_struct_I.pack(length))
        for val2 in val1.values:
          _x = val2
          buff.write(_struct_2I.pack(_x.universe, _x.offset))
          _x = val2.data
          length = len(_x)
          # - if encoded as a list instead, serialize as bytes instead of string
          if type(_x) in [list, tuple]:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
        length = len(val1.easings)
        buff.write(_struct_I.pack(length))
        for val2 in val1.easings:
          length = len(val2.start)
          buff.write(_struct_I.pack(length))
          for val3 in val2.start:
            _x = val3
            buff.write(_struct_2I.pack(_x.universe, _x.offset))
            _x = val3.data
            length = len(_x)
            # - if encoded as a list instead, serialize as bytes instead of string
            if type(_x) in [list, tuple]:
              buff.write(struct.pack('<I%sB'%length, length, *_x))
            else:
              buff.write(struct.pack('<I%ss'%length, length, _x))
          length = len(val2.end)
          buff.write(_struct_I.pack(length))
          for val3 in val2.end:
            _x = val3
            buff.write(_struct_2I.pack(_x.universe, _x.offset))
            _x = val3.data
            length = len(_x)
            # - if encoded as a list instead, serialize as bytes instead of string
            if type(_x) in [list, tuple]:
              buff.write(struct.pack('<I%sB'%length, length, *_x))
            else:
              buff.write(struct.pack('<I%ss'%length, length, _x))
          _x = val2
          buff.write(_struct_2IB.pack(_x.delayMs, _x.durationMs, _x.curve))
        _x = val1
        buff.write(_struct_2I.pack(_x.delayMs, _x.durationMs))
      buff.write(_struct_B.pack(self.loop))
      _x = self.next
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.layers is None:
        self.layers = None
      end = 0
      start = end
      end += 1
      (self.action,) = _struct_b.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.name = str[start:end].decode('utf-8')
      else:
        self.name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.layers = []
      for i in range(0, length):
        val1 = lighting_msgs.msg.DmxFrame()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.values = []
        for i in range(0, length):
          val2 = lighting_msgs.msg.DmxValue()
          _x = val2
          start = end
          end += 8
          (_x.universe, _x.offset,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          val2.data = str[start:end]
          val1.values.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.easings = []
        for i in range(0, length):
          val2 = lighting_msgs.msg.DmxEasing()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          val2.start = []
          for i in range(0, length):
            val3 = lighting_msgs.msg.DmxValue()
            _x = val3
            start = end
            end += 8
            (_x.universe, _x.offset,) = _struct_2I.unpack(str[start:end])
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            val3.data = str[start:end]
            val2.start.append(val3)
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          val2.end = []
          for i in range(0, length):
            val3 = lighting_msgs.msg.DmxValue()
            _x = val3
            start = end
            end += 8
            (_x.universe, _x.offset,) = _struct_2I.unpack(str[start:end])
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            val3.data = str[start:end]
            val2.end.append(val3)
          _x = val2
          start = end
          end += 9
          (_x.delayMs, _x.durationMs, _x.curve,) = _struct_2IB.unpack(str[start:end])
          val1.easings.append(val2)
        _x = val1
        start = end
        end += 8
        (_x.delayMs, _x.durationMs,) = _struct_2I.unpack(str[start:end])
        self.layers.append(val1)
      start = end
      end += 1
      (self.loop,) = _struct_B.unpack(str[start:end])
      self.loop = bool(self.loop)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.next = str[start:end].decode('utf-8')
      else:
        self.next = str[start:end]
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      buff.write(_struct_b.pack(self.action))
      _x = self.name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.layers)
      buff.write(_struct_I.pack(length))
      for val1 in self.layers:
        length = len(val1.values)
        buff.write(_struct_I.pack(length))
        for val2 in val1.values:
          _x = val2
          buff.write(_struct_2I.pack(_x.universe, _x.offset))
          _x = val2.data
          length = len(_x)
          # - if encoded as a list instead, serialize as bytes instead of string
          if type(_x) in [list, tuple]:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
        length = len(val1.easings)
        buff.write(_struct_I.pack(length))
        for val2 in val1.easings:
          length = len(val2.start)
          buff.write(_struct_I.pack(length))
          for val3 in val2.start:
            _x = val3
            buff.write(_struct_2I.pack(_x.universe, _x.offset))
            _x = val3.data
            length = len(_x)
            # - if encoded as a list instead, serialize as bytes instead of string
            if type(_x) in [list, tuple]:
              buff.write(struct.pack('<I%sB'%length, length, *_x))
            else:
              buff.write(struct.pack('<I%ss'%length, length, _x))
          length = len(val2.end)
          buff.write(_struct_I.pack(length))
          for val3 in val2.end:
            _x = val3
            buff.write(_struct_2I.pack(_x.universe, _x.offset))
            _x = val3.data
            length = len(_x)
            # - if encoded as a list instead, serialize as bytes instead of string
            if type(_x) in [list, tuple]:
              buff.write(struct.pack('<I%sB'%length, length, *_x))
            else:
              buff.write(struct.pack('<I%ss'%length, length, _x))
          _x = val2
          buff.write(_struct_2IB.pack(_x.delayMs, _x.durationMs, _x.curve))
        _x = val1
        buff.write(_struct_2I.pack(_x.delayMs, _x.durationMs))
      buff.write(_struct_B.pack(self.loop))
      _x = self.next
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.layers is None:
        self.layers = None
      end = 0
      start = end
      end += 1
      (self.action,) = _struct_b.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.name = str[start:end].decode('utf-8')
      else:
        self.name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.layers = []
      for i in range(0, length):
        val1 = lighting_msgs.msg.DmxFrame()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.values = []
        for i in range(0, length):
          val2 = lighting_msgs.msg.DmxValue()
          _x = val2
          start = end
          end += 8
          (_x.universe, _x.offset,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          val2.data = str[start:end]
          val1.values.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.easings = []
        for i in range(0, length):
          val2 = lighting_msgs.msg.DmxEasing()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          val2.start = []
          for i in range(0, length):
            val3 = lighting_msgs.msg.DmxValue()
            _x = val3
            start = end
            end += 8
            (_x.universe, _x.offset,) = _struct_2I.unpack(str[start:end])
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            val3.data = str[start:end]
            val2.start.append(val3)
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          val2.end = []
          for i in range(0, length):
            val3 = lighting_msgs.msg.DmxValue()
            _x = val3
            start = end
            end += 8
            (_x.universe, _x.offset,) = _struct_2I.unpack(str[start:end])
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            val3.data = str[start:end]
            val2.end.append(val3)
          _x = val2
          start = end
          end += 9
          (_x.delayMs, _x.durationMs, _x.curve,) = _struct_2IB.unpack(str[start:end])
          val1.easings.append(val2)
        _x = val1
        start = end
        end += 8
        (_x.delayMs, _x.durationMs,) = _struct_2I.unpack(str[start:end])
        self.layers.append(val1)
      start = end
      end += 1
      (self.loop,) = _struct_B.unpack(str[start:end])
      self.loop = bool(self.loop)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.next = str[start:end].decode('utf-8')
      else:
        self.next = str[start:end]
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_B = struct.Struct("<B")
_struct_b = struct.Struct("<b")
_struct_2IB = struct.Struct("<2IB")
_struct_2I = struct.Struct("<2I")
