# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from lighting_msgs/DmxFrame.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import lighting_msgs.msg

class DmxFrame(genpy.Message):
  _md5sum = "1b1b0cdf71b186b56f2cf813fbe9ad42"
  _type = "lighting_msgs/DmxFrame"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """DmxValue[] values
DmxEasing[] easings
uint32 delayMs
uint32 durationMs

================================================================================
MSG: lighting_msgs/DmxValue
uint32 universe
uint32 offset
uint8[] data

================================================================================
MSG: lighting_msgs/DmxEasing
DmxValue[] start
DmxValue[] end
uint32 delayMs
uint32 durationMs
uint8 curve

#Easing curve types
uint8 Linear = 0
uint8 InQuad = 1
uint8 OutQuad = 2
uint8 InOutQuad = 3
uint8 OutInQuad = 4
uint8 InCubic = 5
uint8 OutCubic = 6
uint8 InOutCubic = 7
uint8 OutInCubic = 8
uint8 InQuart = 9
uint8 OutQuart = 10
uint8 InOutQuart = 11
uint8 OutInQuart = 12
uint8 InQuint = 13
uint8 OutQuint = 14
uint8 InOutQuint = 15
uint8 OutInQuint = 16
uint8 InSine = 17
uint8 OutSine = 18
uint8 InOutSine = 19
uint8 OutInSine = 20
uint8 InExpo = 21
uint8 OutExpo = 22
uint8 InOutExpo = 23
uint8 OutInExpo = 24
uint8 InCirc = 25
uint8 OutCirc = 26
uint8 InOutCirc = 27
uint8 OutInCirc = 28
uint8 InElastic = 29
uint8 OutElastic = 30
uint8 InOutElastic = 31
uint8 OutInElastic = 32
uint8 InBack = 33
uint8 OutBack = 34
uint8 InOutBack = 35
uint8 OutInBack = 36
uint8 InBounce = 37
uint8 OutBounce = 38
uint8 InOutBounce = 39
uint8 OutInBounce = 40
uint8 Custom = 45

"""
  __slots__ = ['values','easings','delayMs','durationMs']
  _slot_types = ['lighting_msgs/DmxValue[]','lighting_msgs/DmxEasing[]','uint32','uint32']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       values,easings,delayMs,durationMs

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(DmxFrame, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.values is None:
        self.values = []
      if self.easings is None:
        self.easings = []
      if self.delayMs is None:
        self.delayMs = 0
      if self.durationMs is None:
        self.durationMs = 0
    else:
      self.values = []
      self.easings = []
      self.delayMs = 0
      self.durationMs = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      length = len(self.values)
      buff.write(_struct_I.pack(length))
      for val1 in self.values:
        _x = val1
        buff.write(_struct_2I.pack(_x.universe, _x.offset))
        _x = val1.data
        length = len(_x)
        # - if encoded as a list instead, serialize as bytes instead of string
        if type(_x) in [list, tuple]:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.easings)
      buff.write(_struct_I.pack(length))
      for val1 in self.easings:
        length = len(val1.start)
        buff.write(_struct_I.pack(length))
        for val2 in val1.start:
          _x = val2
          buff.write(_struct_2I.pack(_x.universe, _x.offset))
          _x = val2.data
          length = len(_x)
          # - if encoded as a list instead, serialize as bytes instead of string
          if type(_x) in [list, tuple]:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
        length = len(val1.end)
        buff.write(_struct_I.pack(length))
        for val2 in val1.end:
          _x = val2
          buff.write(_struct_2I.pack(_x.universe, _x.offset))
          _x = val2.data
          length = len(_x)
          # - if encoded as a list instead, serialize as bytes instead of string
          if type(_x) in [list, tuple]:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1
        buff.write(_struct_2IB.pack(_x.delayMs, _x.durationMs, _x.curve))
      _x = self
      buff.write(_struct_2I.pack(_x.delayMs, _x.durationMs))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.values is None:
        self.values = None
      if self.easings is None:
        self.easings = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.values = []
      for i in range(0, length):
        val1 = lighting_msgs.msg.DmxValue()
        _x = val1
        start = end
        end += 8
        (_x.universe, _x.offset,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1.data = str[start:end]
        self.values.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.easings = []
      for i in range(0, length):
        val1 = lighting_msgs.msg.DmxEasing()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.start = []
        for i in range(0, length):
          val2 = lighting_msgs.msg.DmxValue()
          _x = val2
          start = end
          end += 8
          (_x.universe, _x.offset,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          val2.data = str[start:end]
          val1.start.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.end = []
        for i in range(0, length):
          val2 = lighting_msgs.msg.DmxValue()
          _x = val2
          start = end
          end += 8
          (_x.universe, _x.offset,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          val2.data = str[start:end]
          val1.end.append(val2)
        _x = val1
        start = end
        end += 9
        (_x.delayMs, _x.durationMs, _x.curve,) = _struct_2IB.unpack(str[start:end])
        self.easings.append(val1)
      _x = self
      start = end
      end += 8
      (_x.delayMs, _x.durationMs,) = _struct_2I.unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      length = len(self.values)
      buff.write(_struct_I.pack(length))
      for val1 in self.values:
        _x = val1
        buff.write(_struct_2I.pack(_x.universe, _x.offset))
        _x = val1.data
        length = len(_x)
        # - if encoded as a list instead, serialize as bytes instead of string
        if type(_x) in [list, tuple]:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.easings)
      buff.write(_struct_I.pack(length))
      for val1 in self.easings:
        length = len(val1.start)
        buff.write(_struct_I.pack(length))
        for val2 in val1.start:
          _x = val2
          buff.write(_struct_2I.pack(_x.universe, _x.offset))
          _x = val2.data
          length = len(_x)
          # - if encoded as a list instead, serialize as bytes instead of string
          if type(_x) in [list, tuple]:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
        length = len(val1.end)
        buff.write(_struct_I.pack(length))
        for val2 in val1.end:
          _x = val2
          buff.write(_struct_2I.pack(_x.universe, _x.offset))
          _x = val2.data
          length = len(_x)
          # - if encoded as a list instead, serialize as bytes instead of string
          if type(_x) in [list, tuple]:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1
        buff.write(_struct_2IB.pack(_x.delayMs, _x.durationMs, _x.curve))
      _x = self
      buff.write(_struct_2I.pack(_x.delayMs, _x.durationMs))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.values is None:
        self.values = None
      if self.easings is None:
        self.easings = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.values = []
      for i in range(0, length):
        val1 = lighting_msgs.msg.DmxValue()
        _x = val1
        start = end
        end += 8
        (_x.universe, _x.offset,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1.data = str[start:end]
        self.values.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.easings = []
      for i in range(0, length):
        val1 = lighting_msgs.msg.DmxEasing()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.start = []
        for i in range(0, length):
          val2 = lighting_msgs.msg.DmxValue()
          _x = val2
          start = end
          end += 8
          (_x.universe, _x.offset,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          val2.data = str[start:end]
          val1.start.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.end = []
        for i in range(0, length):
          val2 = lighting_msgs.msg.DmxValue()
          _x = val2
          start = end
          end += 8
          (_x.universe, _x.offset,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          val2.data = str[start:end]
          val1.end.append(val2)
        _x = val1
        start = end
        end += 9
        (_x.delayMs, _x.durationMs, _x.curve,) = _struct_2IB.unpack(str[start:end])
        self.easings.append(val1)
      _x = self
      start = end
      end += 8
      (_x.delayMs, _x.durationMs,) = _struct_2I.unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_2IB = struct.Struct("<2IB")
_struct_2I = struct.Struct("<2I")
